## openjdk-18 18.0.2+9

=== make/devkit/Makefile ===
#
# Copyright (c) 2013, 2018, Oracle and/or its affiliates. All rights reserved.
# DO NOT ALTER OR REMOVE COPYRIGHT NOTICES OR THIS FILE HEADER.
#
# This code is free software; you can redistribute it and/or modify it
# under the terms of the GNU General Public License version 2 only, as
# published by the Free Software Foundation.  Oracle designates this
# particular file as subject to the "Classpath" exception as provided
# by Oracle in the LICENSE file that accompanied this code.
#
# This code is distributed in the hope that it will be useful, but WITHOUT
# ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
# FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
# version 2 for more details (a copy is included in the LICENSE file that
# accompanied this code).
#
# You should have received a copy of the GNU General Public License version
# 2 along with this work; if not, write to the Free Software Foundation,
# Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301 USA.
#
# Please contact Oracle, 500 Oracle Parkway, Redwood Shores, CA 94065 USA
# or visit www.oracle.com if you need additional information or have any
# questions.
#

################################################################################
#
# This Makefile, together with Tools.gmk, can be used to compile a set of
# gcc based cross compilation, portable, self contained packages, capable
# of building OpenJDK.
#
# By default this Makefile will build a native toolchain for the current
# platform if called with something like this:
#
# make tars BASE_OS=OL
#
# To build the full set of crosstools for additional platforms, use a command
# line looking like this:
#
# make TARGETS="aarch64-linux-gnu" BASE_OS=Fedora
# or
# make TARGETS="arm-linux-gnueabihf ppc64-linux-gnu" BASE_OS=Fedora BASE_OS_VERSION=17
#
# to build several devkits for a specific OS version at once.
# You can find the final results under ../../build/devkit/result/<host>-to-<target>
#
# You may want the native toolchain to be used when compiling the cross
# compilation toolchains. To achieve this, first build the native toolchain,
# then add the bin directory from this build to the path when invoking this
# makefile again for cross compilation. Ex:
#
# PATH=$PWD/../../build/devkit/result/x86_64-linux-gnu-to-x86_64-linux-gnu/bin:$PATH \
#    make TARGETS="arm-linux-gnueabihf,ppc64-linux-gnu" BASE_OS=Fedora
#
# This is the makefile which iterates over all host and target platforms.
#

COMMA := ,

os := $(shell uname -o)
cpu := $(shell uname -p)

# Figure out what platform this is building on.
me := $(cpu)-$(if $(findstring Linux,$(os)),linux-gnu)

$(info Building on platform $(me))

#
# By default just build for the current platform, which is assumed to be Linux
#
ifeq ($(TARGETS), )
  platforms := $(me)
  host_platforms := $(platforms)
else
  platforms := $(subst $(COMMA), , $(TARGETS))
  host_platforms := $(me)
endif
target_platforms := $(platforms)
$(info host_platforms $(host_platforms))
$(info target_platforms $(target_platforms))

all compile : $(platforms)

ifeq (,$(SKIP_ME))
  $(foreach p,$(filter-out $(me),$(platforms)),$(eval $(p) : $$(me)))
endif

OUTPUT_ROOT = $(abspath ../../build/devkit)
RESULT = $(OUTPUT_ROOT)/result

submakevars = HOST=$@ BUILD=$(me) RESULT=$(RESULT) OUTPUT_ROOT=$(OUTPUT_ROOT)

$(host_platforms) :
	@echo 'Building compilers for $@'
	@echo 'Targets: $(target_platforms)'
	for p in $(filter $@, $(target_platforms)) $(filter-out $@, $(target_platforms)); do \
	  $(MAKE) -f Tools.gmk download-rpms $(submakevars) \
              TARGET=$$p PREFIX=$(RESULT)/$@-to-$$p && \
	  $(MAKE) -f Tools.gmk all $(submakevars) \
              TARGET=$$p PREFIX=$(RESULT)/$@-to-$$p && \
	  $(MAKE) -f Tools.gmk ccache $(submakevars) \
              TARGET=$@ PREFIX=$(RESULT)/$@-to-$$p || exit 1 ; \
	done
	@echo 'All done"'

today := $(shell date +%Y%m%d)

define Mktar
  $(1)-to-$(2)_tar = $$(RESULT)/sdk-$(1)-to-$(2)-$$(today).tar.gz
  $$($(1)-to-$(2)_tar) : PLATFORM = $(1)-to-$(2)
  TARFILES += $$($(1)-to-$(2)_tar)
endef

$(foreach p,$(host_platforms),$(foreach t,$(target_platforms),$(eval $(call Mktar,$(p),$(t)))))

tars : all $(TARFILES)
onlytars : $(TARFILES)
%.tar.gz :
	$(MAKE) -r -f Tars.gmk SRC_DIR=$(RESULT)/$(PLATFORM) TAR_FILE=$@

clean :
	rm -rf $(addprefix ../../build/devkit/, result $(host_platforms))
dist-clean: clean
	rm -rf $(addprefix ../../build/devkit/, src download)

FORCE :
.PHONY : all compile tars $(configs) $(host_platforms) clean dist-clean

=== test/jdk/java/rmi/reliability/benchmark/bench/rmi/Makefile ===
#
# Copyright (c) 2000, 2020, Oracle and/or its affiliates. All rights reserved.
# DO NOT ALTER OR REMOVE COPYRIGHT NOTICES OR THIS FILE HEADER.
#
# This code is free software; you can redistribute it and/or modify it
# under the terms of the GNU General Public License version 2 only, as
# published by the Free Software Foundation.
#
# This code is distributed in the hope that it will be useful, but WITHOUT
# ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
# FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
# version 2 for more details (a copy is included in the LICENSE file that
# accompanied this code).
#
# You should have received a copy of the GNU General Public License version
# 2 along with this work; if not, write to the Free Software Foundation,
# Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301 USA.
#
# Please contact Oracle, 500 Oracle Parkway, Redwood Shores, CA 94065 USA
# or visit www.oracle.com if you need additional information or have any
# questions.
#

#
#
#
# RMI benchmarks makefile
#

BUILD_DIR = ../..
JAVA_FILES = BenchServer.java \
	BenchServerImpl.java \
	BooleanArrayCalls.java \
	BooleanCalls.java \
	ByteArrayCalls.java \
	ByteCalls.java \
	CharArrayCalls.java \
	CharCalls.java \
	ClassLoading.java \
	DoubleArrayCalls.java \
	DoubleCalls.java \
	ExceptionCalls.java \
	ExportObjs.java \
	FloatArrayCalls.java \
	FloatCalls.java \
	IntArrayCalls.java \
	IntCalls.java \
	LongArrayCalls.java \
	LongCalls.java \
	Main.java \
	NullCalls.java \
	ObjArrayCalls.java \
	ObjTreeCalls.java \
	ProxyArrayCalls.java \
	RemoteObjArrayCalls.java \
	ShortArrayCalls.java \
	ShortCalls.java \
	SmallObjTreeCalls.java \
	TheTerminator.java

all: .classes altroot.dir

.classes: $(JAVA_FILES)
	javac -d $(BUILD_DIR) $(JAVA_FILES)
	touch .classes

altroot.dir:
	cd altroot ; $(MAKE)

altroot.clean:
	cd altroot ; $(MAKE) clean

clean: altroot.clean
	rm -f *.class .classes

## openjdk-18 18~15ea

=== debian/changelog ===
openjdk-18 (18~15ea-4) unstable; urgency=medium

  * Fix installation of the zero VM, now installed as zero, not as server.

 -- Matthias Klose <doko@ubuntu.com>  Fri, 17 Sep 2021 18:43:49 +0200

openjdk-18 (18~15ea-1) unstable; urgency=medium

  * OpenJDK 18 snapshot, build 15.

 -- Matthias Klose <doko@ubuntu.com>  Thu, 16 Sep 2021 10:10:47 +0200

openjdk-18 (18~12ea-1) unstable; urgency=medium

  * OpenJDK 18 snapshot, build 12.
  * Encode the early-access status into the package version.

 -- Matthias Klose <doko@ubuntu.com>  Thu, 26 Aug 2021 12:46:22 +0200

openjdk-18 (18~2-1) experimental; urgency=medium

  * OpenJDK 18 snapshot, build 2.
  * Only build using lto with GCC 11.
  * Build using GCC 11 in recent distributions.
  * Remove rimd, removed upstream.

 -- Matthias Klose <doko@ubuntu.com>  Thu, 17 Jun 2021 15:00:57 +0200

openjdk-17 (17~24-1) unstable; urgency=medium

  * OpenJDK 17 snapshot, build 24.
  * Drop the work around for JDK 8211105.
  * Remove jaotc (the experimental JIT compiler), removed upstream.
  * Add an (unapplied) patch to replace OASIS header files with ones
    imported from NSPR and NSS. See #985765.  Not reviewed, not applying.

 -- Matthias Klose <doko@ubuntu.com>  Thu, 27 May 2021 11:26:59 +0200

openjdk-17 (17~19-1) unstable; urgency=high

  * OpenJDK 17 snapshot, build 19.
    - Fix JDK-8250568: Less ambiguous processing (CVE-2021-2161).
    - Fix JDK-8249906: Enhance opening JARs (CVE-2021-2163).

 -- Matthias Klose <doko@ubuntu.com>  Thu, 22 Apr 2021 09:51:43 +0200

openjdk-17 (17~17-1) unstable; urgency=medium

  * OpenJDK 17 snapshot, build 17.
  * Refresh patches.
  * Prefer to build using openjdk-17 instead of -16. Closes: #986526.

 -- Matthias Klose <doko@ubuntu.com>  Thu, 08 Apr 2021 09:37:40 +0200

openjdk-17 (17~15-1) unstable; urgency=medium

  * OpenJDK 17 snapshot, build 15.
  * Fix another upstream typo to build with external harfbuzz. Closes: #985668.
  * Disable running the tests on mipsel and mips64el.  Times out, and if it
    succeeds, it taken at least five days to run.

 -- Matthias Klose <doko@ubuntu.com>  Thu, 25 Mar 2021 10:31:15 +0100

openjdk-17 (17~14-1) unstable; urgency=medium

  * OpenJDK 17 snapshot, build 14.
  * Don't use the triplet-prefixed binutils tools for backports.
  * Simplify compiler selection for backports.
  * Fix build with older glibc versions. See JDK-8262501.
  * Apply untested patch suggested to fix mips issue. See #983878.

 -- Matthias Klose <doko@ubuntu.com>  Thu, 18 Mar 2021 19:42:16 +0100

openjdk-17 (17~11-1) unstable; urgency=medium

  * OpenJDK 17 snapshot, build 11.
  * Configure --with-copyright-year. Addresses: #956154.
  * Restore the libpcsclite-dlopen patch. Closes: #983465.
  * Don't run the testsuite on armel and riscv64. Crashing the buildds.

 -- Matthias Klose <doko@ubuntu.com>  Thu, 25 Feb 2021 10:33:32 +0100

openjdk-17 (17~10-2) unstable; urgency=medium

  * Fix the build logic, jaotc and jhsdb tools not available on all archs.
  * Ship the jfc files used by jfr.
  * reproducible-build-jmod.diff: Fall back to the unpatched behavior
    for backports.
  * Only build with system harfbuzz for recent releases.

 -- Matthias Klose <doko@ubuntu.com>  Sat, 20 Feb 2021 12:02:45 +0100

openjdk-17 (17~10-1) unstable; urgency=medium

  * OpenJDK 17 snapshot, build 10.
  * Fix building with OpenJDK 17 as the boot jdk.
  * Build with Rules-Requires-Root: no.
  * Move libawt_xawt.so, libjawt.so into the jre package. Addresses: #908058.
  * Move the jfr binary from -jre-headless to -jdk-headless. Development tool.

 -- Matthias Klose <doko@ubuntu.com>  Fri, 19 Feb 2021 13:12:19 +0100

openjdk-17 (17~9-1) unstable; urgency=medium

  * OpenJDK 17 snapshot, build 9.
  * Enable running the tests.
  * Remove the disable-doclint-by-default patch. Was not applied anymore
    in 17.  Closes: #982521.

 -- Matthias Klose <doko@ubuntu.com>  Thu, 11 Feb 2021 10:13:25 +0000

openjdk-17 (17~8-1) unstable; urgency=medium

  * OpenJDK 17 snapshot, build 8.
  * Don't try to apply the removed alpha-float-const patch.
  * Drop the powerpcspe packaging bits.

 -- Matthias Klose <doko@ubuntu.com>  Thu, 04 Feb 2021 14:35:28 +0100

openjdk-17 (17~7-1) unstable; urgency=medium

  * OpenJDK 17 snapshot, build 7.
  * Update watch file.
  * Use debugedit to generate unique build-id's and remove the openjdk-N-dbg
    file conflicts.
  * Remove KFreeBSD build support and patches, not updated since OpenJDK 8.
  * Remove obsolete patches: alpha-float-const, libpcsclite-dlopen,
    parallel-build-fix, s390x-thread-stack-size.

 -- Matthias Klose <doko@ubuntu.com>  Thu, 28 Jan 2021 14:52:27 +0100

openjdk-17 (17~5-1) unstable; urgency=medium

  * OpenJDK 17 snapshot, build 5.

 -- Matthias Klose <doko@ubuntu.com>  Tue, 19 Jan 2021 10:29:50 +0100

openjdk-17 (17~4-0ubuntu1) hirsute; urgency=medium

  * OpenJDK 17 snapshot, build 4.

 -- Matthias Klose <doko@ubuntu.com>  Sat, 09 Jan 2021 17:25:46 +0100

openjdk-17 (17~3-1) experimental; urgency=medium

  * OpenJDK 17 snapshot, build 3.
  * OpenJDK 17 is supposed to be the next OpenJDK LTS release seeing extended
    updates and security support.

 -- Matthias Klose <doko@ubuntu.com>  Mon, 28 Dec 2020 13:57:12 +0100

openjdk-16 (16~29-1) unstable; urgency=medium

  * OpenJDK 16 snapshot, build 29.

 -- Matthias Klose <doko@ubuntu.com>  Mon, 28 Dec 2020 12:44:30 +0100

openjdk-16 (16~27-2) unstable; urgency=medium

  * Fix installation on sparc64.
  * Link with libatomic for more zero builds.
  * Re-enable zero on armhf.

 -- Matthias Klose <doko@ubuntu.com>  Fri, 04 Dec 2020 10:01:45 +0100

openjdk-16 (16~27-1) unstable; urgency=medium

  * OpenJDK 16 snapshot, build 27.
  * Bump standards version.

 -- Matthias Klose <doko@ubuntu.com>  Thu, 03 Dec 2020 16:42:51 +0100

openjdk-16 (16~14-1) experimental; urgency=medium

  * OpenJDK 16 snapshot, build 14.
  * Build with system harfbuzz.

 -- Matthias Klose <doko@ubuntu.com>  Sat, 07 Nov 2020 14:35:22 +0100



=== debian/control ===
Source: openjdk-18
Section: java
Priority: optional
Maintainer: OpenJDK Team <openjdk-17@packages.debian.org>
Uploaders: Matthias Klose <doko@ubuntu.com>
Build-Depends: debhelper (>= 11),
  m4, lsb-release, zip, unzip,
  sharutils, gawk, cpio, pkg-config, procps, wdiff, fastjar (>= 2:0.96-0ubuntu2),
  time, strip-nondeterminism, debugedit (>= 4.16),
  file,
  autoconf, automake, autotools-dev, ant, ant-optional,
  g++-11 <!cross>,
  openjdk-17-jdk-headless:native | openjdk-16-jdk-headless:native,
  libxtst-dev, libxi-dev, libxt-dev, libxaw7-dev, libxrender-dev, libcups2-dev, libasound2-dev, liblcms2-dev, libfreetype6-dev (>= 2.2.1), libxinerama-dev, libkrb5-dev, xsltproc, libpcsclite-dev, libxrandr-dev, libelf-dev, libfontconfig1-dev, libgtk2.0-0 | libgtk-3-0, libharfbuzz-dev,
  libffi-dev,
  zlib1g-dev:native, zlib1g-dev, libattr1-dev, libpng-dev, libjpeg-dev, libgif-dev, 
  libnss3-dev (>= 2:3.17.1),
  openjdk-18-jdk-headless <cross>,
Build-Depends-Indep: graphviz, pandoc,
Rules-Requires-Root: no
Standards-Version: 4.5.1
Homepage: https://openjdk.java.net/
Vcs-Browser: https://salsa.debian.org/openjdk-team/openjdk
Vcs-Git: https://salsa.debian.org/openjdk-team/openjdk.git

Package: openjdk-18-jdk-headless
Architecture: alpha amd64 armel armhf arm64 i386 ia64 mips mipsel mips64 mips64el powerpc ppc64 ppc64el m68k riscv64 sh4 sparc sparc64 s390x x32
Multi-Arch: same
Pre-Depends: ${dpkg:Depends}
Depends: openjdk-18-jre-headless (= ${binary:Version}),
  ${shlibs:Depends}, ${misc:Depends}
Suggests: openjdk-18-demo, openjdk-18-source
Provides: java-sdk-headless, java2-sdk-headless,
  java5-sdk-headless, java6-sdk-headless,
  java7-sdk-headless, java8-sdk-headless,
  java9-sdk-headless, java10-sdk-headless,
  java11-sdk-headless, java12-sdk-headless,
  java13-sdk-headless, java14-sdk-headless, java15-sdk-headless,
  java16-sdk-headless, java17-sdk-headless,
  java-compiler
Breaks: openjdk-17-jre-headless (<< 17~10)
Replaces: openjdk-17-jre-headless (<< 17~10)
Description: OpenJDK Development Kit (JDK) (headless)
 OpenJDK is a development environment for building applications,
 applets, and components using the Java programming language.

Package: openjdk-18-jre-headless
Architecture: alpha amd64 armel armhf arm64 i386 ia64 mips mipsel mips64 mips64el powerpc ppc64 ppc64el m68k riscv64 sh4 sparc sparc64 s390x x32
Multi-Arch: same
Pre-Depends: ${dpkg:Depends}
Depends: ${jredefault:Depends}, ${cacert:Depends},
  ${jcommon:Depends}, ${dlopenhl:Depends},
  ${mountpoint:Depends},
  ${shlibs:Depends}, ${misc:Depends}
Recommends: ${dlopenhl:Recommends}
Suggests: libnss-mdns,
  fonts-dejavu-extra,
  fonts-ipafont-gothic, fonts-ipafont-mincho, fonts-wqy-microhei | fonts-wqy-zenhei, fonts-indic,
Provides: java-runtime-headless, java2-runtime-headless,
  java5-runtime-headless, java6-runtime-headless,
  java7-runtime-headless, java8-runtime-headless,
  java9-runtime-headless, java10-runtime-headless,
  java11-runtime-headless, java12-runtime-headless,
  java13-runtime-headless, java14-runtime-headless, java15-runtime-headless,
  java16-runtime-headless, java17-runtime-headless,
  ${defaultvm:Provides}, ${jvm:Provides}
Breaks: ${jrehl:Breaks}
Conflicts: oracle-java11-installer, openjdk-11-jdk-headless (<< 11~18-2)
Replaces: openjdk-11-jdk-headless (<< 11~18-2)
Description: OpenJDK Java runtime, using ${vm:Name} (headless)
 Minimal Java runtime - needed for executing non GUI Java programs,
 using ${vm:Name}.

Package: openjdk-18-jdk
Architecture: alpha amd64 armel armhf arm64 i386 ia64 mips mipsel mips64 mips64el powerpc ppc64 ppc64el m68k riscv64 sh4 sparc sparc64 s390x x32
Multi-Arch: same
Pre-Depends: ${dpkg:Depends}
Depends: openjdk-18-jre (= ${binary:Version}),
  openjdk-18-jdk-headless (= ${binary:Version}),
  ${shlibs:Depends}, ${misc:Depends}
Recommends: libxt-dev
Suggests: openjdk-18-demo, openjdk-18-source, visualvm
Provides: java-sdk, java2-sdk, java5-sdk, java6-sdk,
  java7-sdk, java8-sdk, java9-sdk, java10-sdk, java11-sdk,
  java12-sdk, java13-sdk, java14-sdk, java15-sdk, java16-sdk, java17-sdk,
  java-compiler
Description: OpenJDK Development Kit (JDK)
 OpenJDK is a development environment for building applications,
 applets, and components using the Java programming language.

Package: openjdk-18-jre
Architecture: alpha amd64 armel armhf arm64 i386 ia64 mips mipsel mips64 mips64el powerpc ppc64 ppc64el m68k riscv64 sh4 sparc sparc64 s390x x32
Multi-Arch: same
Pre-Depends: ${dpkg:Depends}
Depends: openjdk-18-jre-headless (= ${binary:Version}),
  ${xandsound:Depends}, ${dlopenjre:Depends},
  ${shlibs:Depends}, ${misc:Depends}
Recommends: ${dlopenjre:Recommends}, ${bridge:Recommends}, fonts-dejavu-extra
Provides: java-runtime, java2-runtime,
  java5-runtime, java6-runtime,
  java7-runtime, java8-runtime,
  java9-runtime, java10-runtime,
  java11-runtime, java12-runtime,
  java13-runtime, java14-runtime, java15-runtime,
  java16-runtime, java17-runtime,
Breaks: openjdk-17-jre-headless (<< 17~10)
Replaces: openjdk-17-jre-headless (<< 17~10)
Description: OpenJDK Java runtime, using ${vm:Name}
 Full Java runtime environment - needed for executing Java GUI and Webstart
 programs, using ${vm:Name}.

Package: openjdk-18-demo
Architecture: alpha amd64 armel armhf arm64 i386 ia64 mips mipsel mips64 mips64el powerpc ppc64 ppc64el m68k riscv64 sh4 sparc sparc64 s390x x32
Priority: optional
Pre-Depends: ${dpkg:Depends}
Depends: openjdk-18-jre (= ${binary:Version}),
  ${shlibs:Depends}, ${misc:Depends}
Description: Java runtime based on OpenJDK (demos and examples)
 OpenJDK Java runtime

Package: openjdk-18-source
Architecture: all
Multi-Arch: foreign
Priority: optional
Pre-Depends: ${dpkg:Depends}
Depends: openjdk-18-jdk (>= ${source:Version}),
  ${misc:Depends}
Description: OpenJDK Development Kit (JDK) source files
 OpenJDK is a development environment for building applications,
 applets, and components using the Java programming language.
 .
 This package contains the Java programming language source files
 (src.zip) for all classes that make up the Java core API.

Package: openjdk-18-doc
Section: doc
Pre-Depends: ${dpkg:Depends}
Architecture: all
Multi-Arch: foreign
Priority: optional
Depends: ${misc:Depends},
  libjs-jquery,
  libjs-jquery-ui,
  libjs-jquery-ui-theme-base,
Suggests: openjdk-18-jdk
Description: OpenJDK Development Kit (JDK) documentation
 OpenJDK is a development environment for building applications,
 applets, and components using the Java programming language.
 .
 This package contains the API documentation.

Package: openjdk-18-dbg
Architecture: alpha amd64 armel armhf arm64 i386 ia64 mips mipsel mips64 mips64el powerpc ppc64 ppc64el m68k riscv64 sh4 sparc sparc64 s390x x32
Multi-Arch: same
Priority: optional
Section: debug
Pre-Depends: ${dpkg:Depends}
Depends: openjdk-18-jre-headless (= ${binary:Version}),
   ${misc:Depends}
Recommends: openjdk-18-jre (= ${binary:Version})
Suggests: openjdk-18-jdk (= ${binary:Version})
Conflicts: ${dbg:Conflicts}
Description: Java runtime based on OpenJDK (debugging symbols)
 OpenJDK is a development environment for building applications,
 applets, and components using the Java programming language.
 .
 This package contains the debugging symbols.

Package: openjdk-18-jre-zero
Architecture: amd64 i386 arm64 armhf ppc64 ppc64el s390x
Multi-Arch: same
Priority: optional
Pre-Depends: ${dpkg:Depends}
Depends: openjdk-18-jre-headless (= ${binary:Version}), ${shlibs:Depends}, ${misc:Depends}
Provides: ${zerovm:Provides}
Description: Alternative JVM for OpenJDK, using Zero
 The package provides an alternative runtime using the Zero VM. Built on
 architectures in addition to the Hotspot VM as a debugging aid for those
 architectures which don't have a Hotspot VM.
 .
 The VM is started with the option `-zero'. See the README.Debian for details.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

unexport LANG LC_ALL

dh_version := $(shell dpkg-query -f '$${Version}\n' -W debhelper | sed -n 's/^\(.\).*/\1/p')

# using brace expansion and substring replacements (${var:0:2}).
SHELL = /bin/bash

# use gnu time in verbose mode if available, otherwise default to the shell builtin
ifneq (,$(wildcard /usr/bin/time))
  TIME = /usr/bin/time -v
else
  TIME = time
endif

vafilt = $(subst $(2)=,,$(filter $(2)=%,$(1)))

DPKG_VARS		:= $(shell dpkg-architecture)
DEB_HOST_GNU_TYPE	?= $(call vafilt,$(DPKG_VARS),DEB_HOST_GNU_TYPE)
DEB_BUILD_GNU_TYPE	?= $(call vafilt,$(DPKG_VARS),DEB_BUILD_GNU_TYPE)
DEB_HOST_ARCH		?= $(call vafilt,$(DPKG_VARS),DEB_HOST_ARCH)
DEB_BUILD_ARCH		?= $(call vafilt,$(DPKG_VARS),DEB_BUILD_ARCH)
DEB_HOST_ARCH_CPU	?= $(call vafilt,$(DPKG_VARS),DEB_HOST_ARCH_CPU)
DEB_HOST_MULTIARCH	?= $(call vafilt,$(DPKG_VARS),DEB_HOST_MULTIARCH)

PATH := $(CURDIR)/bin:$(PATH)
export PATH

CHANGELOG_VARS := $(shell dpkg-parsechangelog | sed -n 's/ /_/g;/^[^_]/s/^\([^:]*\):_\(.*\)/\1=\2/p')
PKGSOURCE := $(call vafilt,$(CHANGELOG_VARS),Source)
PKGVERSION := $(call vafilt,$(CHANGELOG_VARS),Version)
PKGYEAR := $(shell echo $(call vafilt,$(CHANGELOG_VARS),Timestamp) | date --utc +%Y)

distribution := $(shell lsb_release --id --short)
distrel := $(shell lsb_release --codename --short)
derivative := $(shell if dpkg-vendor --derives-from Ubuntu; then echo Ubuntu; \
               elif dpkg-vendor --derives-from Debian; then echo Debian; \
               else echo Unknown; fi)
ifeq ($(distrel),n/a)
  distrel := sid
endif

ifneq (,$(filter $(distrel),precise))
  OBJCOPY := objcopy
  STRIP := strip
else
  OBJCOPY := $(DEB_HOST_GNU_TYPE)-objcopy
  STRIP := $(DEB_HOST_GNU_TYPE)-strip
endif

multiarch_dir = /$(DEB_HOST_MULTIARCH)

hotspot_archs	= amd64 i386 arm64 armhf ppc64 ppc64el s390x
jtreg_archs	= $(hotspot_archs) alpha ia64 powerpc ppc64 sh4 x32
jtreg_archs	+= armel mipsel mips64el
jtreg_archs	+= riscv64

# FIXME: use bootcycle builds for zero archs?
bootcycle_build = $(if $(filter $(DEB_HOST_ARCH), $(hotspot_archs)),yes)
#bootcycle_build = $(if $(filter $(DEB_HOST_ARCH), amd64 i386),yes)
#bootcycle_build =
zbootcycle_build =
zbootcycle_build = yes
ifneq ($(DEB_HOST_ARCH),$(DEB_BUILD_ARCH))
  bootcycle_build =
  zbootcycle_build =
endif
ifneq (,$(filter nobootcycle, $(DEB_BUILD_OPTIONS)))
  bootcycle_build =
  zbootcycle_build =
endif

ifneq (,$(filter $(distrel),lucid precise quantal raring saucy trusty utopic vivid wily lenny etch squeeze wheezy jessie))
  is_default = no
else
  is_default = yes
endif

#is_upstream_release = yes

srcdir		= .
builddir	= build
zbuilddir	= build-zero

VENDOR		= openjdk
Vendor		= OpenJDK
TOP		= usr/lib/jvm
origin		= openjdk
basename	= openjdk-$(shortver)
ifneq (,$(filter $(DEB_HOST_ARCH), $(hotspot_archs)))
  priority	= $(if $(filter yes, $(is_default)),1811,1809)
  vm_name	= Hotspot JIT
else
  priority	= $(if $(filter yes, $(is_default)),1804,1803)
  vm_name	= Hotspot Zero
endif
jvmver		= 1.18.0
shortver	= 18
v_debian	:= $(shell echo $(PKGVERSION) | sed 's/ea//')
v_upstream	:= $(shell echo $(v_debian) | sed 's/-[^-][^-]*$$//')
v_pkgrel	:= $(shell echo $(v_debian) | sed 's/^.*-//')
# FIXME. currently v_upstream like 11~4
#v_upbase	:= $(word 1, $(subst +, , $(v_upstream)))
#v_upbuild	:= $(word 2, $(subst +, , $(v_upstream)))
v_upbase	:= $(word 1, $(subst ~, , $(v_upstream)))
v_upbuild	:= $(word 2, $(subst ~, , $(v_upstream)))
# that should be the package version ...

#$(warning XXXXX $(v_upstream) / $(v_pkgrel) / $(v_upbase) / $(v_upbuild))

#ifneq ($(v_debian),$(v_upbase)+$(v_upbuild)-$(v_pkgrel))
#  $(error wrong version: $(v_upbase)+$(v_upbuild)-$(v_pkgrel) should be: $(v_debian))
#endif
ifneq ($(v_debian),$(v_upbase)~$(v_upbuild)-$(v_pkgrel))
  $(error wrong version: $(v_upbase)~$(v_upbuild)-$(v_pkgrel) should be: $(v_debian))
endif

ifneq (,$(DEB_HOST_MULTIARCH))
  jdirname	= java-$(shortver)-$(origin)-$(DEB_HOST_ARCH)
  jdiralias	= java-$(jvmver)-$(origin)-$(DEB_HOST_ARCH)
  basedir	= $(TOP)/$(jdirname)
  commonbasedir	= $(TOP)/java-$(shortver)-$(origin)-common
  commonbasedir	= $(basedir)
  etcdir	= etc/java-$(shortver)-$(origin)
else
  jdirname	= java-$(shortver)-$(origin)
  jdiralias	= java-$(jvmver)-$(origin)
  basedir	= $(TOP)/$(jdirname)
  commonbasedir	= $(TOP)/java-$(shortver)-$(origin)
  etcdir	= etc/$(jdirname)
endif
security	= $(etcdir)/security
ifeq ($(bootcycle_build),yes)
  sdkimg	= bootcycle-build/images/jdk
  build_target	= bootcycle-images test-image
else
  sdkimg	= images/jdk
  build_target	= images test-image
endif
ifeq ($(zbootcycle_build),yes)
  zsdkimg	= bootcycle-build/images/jdk
  zbuild_target	= bootcycle-images test-image
else
  zsdkimg	= images/jdk
  zbuild_target	= images test-image
endif

# Support parallel=<n> in DEB_BUILD_OPTIONS (see #209008)
COMMA=,
SPACE = $(EMPTY) $(EMPTY)
ifneq (,$(filter parallel=%,$(subst $(COMMA), ,$(DEB_BUILD_OPTIONS))))
  NJOBS = $(subst parallel=,,$(filter parallel=%,$(subst $(COMMA), ,$(DEB_BUILD_OPTIONS))))
endif

with_check = $(if $(findstring nocheck, $(DEB_BUILD_OPTIONS)),,yes)
ifneq (,$(filter $(DEB_HOST_ARCH), alpha armel mipsel mips64el riscv64))
  with_check = disabled running check on $(DEB_HOST_ARCH)
endif
# no jtreg backport yet
ifneq (,$(filter $(distrel), precise trusty xenial bionic))
  with_check = disabled for $(distrel)
endif
with_check = disabled, more recent jtreg needed

with_docs = $(if $(findstring nodoc, $(DEB_BUILD_OPTIONS)),,yes)
ifneq (,$(filter $(distrel), precise trusty))
  with_docs =
endif
#with_check = disabled for this upload

with_wqy_zenhai = $(if $(filter $(distrel),lenny),,yes)

arch_map	:= alpha=alpha arm=arm armel=arm armhf=arm arm64=aarch64 amd64=amd64 hppa=parisc i386=i586 m68k=m68k mips=mips mipsel=mipsel mips64=mips64 mips64el=mips64el powerpc=ppc ppc64=ppc64 ppc64el=ppc64le riscv64=riscv64 sparc=sparc sparc64=sparcv9 sh4=sh s390x=s390x ia64=ia64 x32=x32

jvmarch		:= $(strip $(patsubst $(DEB_HOST_ARCH_CPU)=%, %, \
			$(filter $(DEB_HOST_ARCH_CPU)=%, $(arch_map))))
ifeq ($(DEB_HOST_ARCH),x32)
  jvmarch := x32
endif

default_vm = $(if $(filter $(DEB_HOST_ARCH), $(hotspot_archs)),hotspot,zero)

any_archs = alpha amd64 armel armhf arm64 i386 ia64 mips mipsel mips64 mips64el powerpc ppc64 ppc64el m68k riscv64 sh4 sparc sparc64 s390x x32

altzero_archs = $(hotspot_archs)
ifneq (,$(filter $(distrel),trusty))
  altzero_archs := $(filter-out arm64, $(altzero_archs))
endif
# FIXME: https://launchpad.net/ubuntu/+source/openjdk-lts/11.0.5+6-1ubuntu1
# ftbfs on armhf, also in OpenJDK 15, now fixed in 16?
#altzero_archs := $(filter-out armhf, $(altzero_archs))

ifneq (,$(filter noaltzero, $(DEB_BUILD_OPTIONS)))
  altzero_archs =
else ifneq (,$(filter $(DEB_HOST_ARCH), $(altzero_archs)))
  alternate_vms += zero
  zero_dir = zero
endif

# needed for the jexec build
export DEBIAN_JDK_BASE_DIR := /$(basedir)

BOOTJDK_HOME := $(strip $(subst /bin/javac,, $(firstword $(wildcard \
			/usr/lib/jvm/java-17-openjdk-$(DEB_BUILD_ARCH)/bin/javac \
			/usr/lib/jvm/java-18-openjdk-$(DEB_BUILD_ARCH)/bin/javac \
		))))

ifeq ($(DEB_BUILD_ARCH),$(DEB_HOST_ARCH))
  BUILDJDK_HOME = $(CURDIR)/$(builddir)/$(sdkimg)
else
  BUILDJDK_HOME = $(BOOTJDK_HOME)
endif

ifneq (,$(filter $(distrel),saucy))
  export CC = gcc-4.8
  export CXX = g++-4.8
  bd_gcc = g++-4.8,
else ifneq (,$(filter $(distrel),utopic vivid jessie))
  export CC = gcc-4.9
  export CXX = g++-4.9
  bd_gcc = g++-4.9,
else ifneq (,$(filter $(distrel),wily))
  ifneq (,$(filter $(DEB_HOST_ARCH), $(hotspot_archs)))
    export CC = $(DEB_HOST_GNU_TYPE)-gcc-5
    export CXX = $(DEB_HOST_GNU_TYPE)-g++-5
    # FIXME: altzero seems to build with GCC 5 on i386, amd64, ppc64el ...
    ifneq (,$(filter $(DEB_HOST_ARCH), arm64))
      ZERO_CC = $(DEB_HOST_GNU_TYPE)-gcc-4.9
      ZERO_CXX = $(DEB_HOST_GNU_TYPE)-g++-4.9
    endif
  else
    export CC = $(DEB_HOST_GNU_TYPE)-gcc-4.9

=== debian/tests/control ===
Test-Command: java --version
Depends: openjdk-18-jre-headless
Restrictions: superficial

Test-Command: javac --version
Depends: openjdk-18-jdk-headless
Restrictions: superficial

#Tests: hotspot, jaxp, langtools
#Depends: @, default-jre-headless, jtreg:native (>= 6+1-0~), testng:native, build-essential
#Restrictions: allow-stderr, skippable, flaky

#Tests: jdk
#Depends: @, default-jre-headless, jtreg:native (>= 6+1-0~), testng:native, build-essential, xfwm4:native, xvfb, dbus-x11
#Restrictions: allow-stderr, skippable, flaky

## openjdk-18 18~36ea

=== debian/changelog ===
openjdk-18 (18~36ea-1) unstable; urgency=medium

  * OpenJDK 18 snapshot, build 36 (first release candidate).

 -- Matthias Klose <doko@ubuntu.com>  Thu, 17 Feb 2022 09:22:24 +0100

openjdk-18 (18~32ea-1) unstable; urgency=medium

  * OpenJDK 18 snapshot, build 32.
  * Add jwebserver into the openjdk-jdk-headless package.

 -- Matthias Klose <doko@ubuntu.com>  Fri, 21 Jan 2022 11:45:56 +0100

openjdk-18 (18~20ea-1) unstable; urgency=medium

  * OpenJDK 18 snapshot, build 20.
  * Bump standards version.

 -- Matthias Klose <doko@ubuntu.com>  Thu, 21 Oct 2021 08:36:16 +0200

=== debian/control ===
--- 
+++ 
@@ -10,7 +10,7 @@
   file,
   autoconf, automake, autotools-dev, ant, ant-optional,
   g++-11 <!cross>,
-  openjdk-17-jdk-headless:native | openjdk-16-jdk-headless:native,
+  openjdk-18-jdk-headless:native | openjdk-17-jdk-headless:native,
   libxtst-dev, libxi-dev, libxt-dev, libxaw7-dev, libxrender-dev, libcups2-dev, libasound2-dev, liblcms2-dev, libfreetype6-dev (>= 2.2.1), libxinerama-dev, libkrb5-dev, xsltproc, libpcsclite-dev, libxrandr-dev, libelf-dev, libfontconfig1-dev, libgtk2.0-0 | libgtk-3-0, libharfbuzz-dev,
   libffi-dev,
   zlib1g-dev:native, zlib1g-dev, libattr1-dev, libpng-dev, libjpeg-dev, libgif-dev, 
@@ -18,7 +18,7 @@
   openjdk-18-jdk-headless <cross>,
 Build-Depends-Indep: graphviz, pandoc,
 Rules-Requires-Root: no
-Standards-Version: 4.5.1
+Standards-Version: 4.6.0
 Homepage: https://openjdk.java.net/
 Vcs-Browser: https://salsa.debian.org/openjdk-team/openjdk
 Vcs-Git: https://salsa.debian.org/openjdk-team/openjdk.git

=== debian/tests/control ===
Test-Command: java --version
Depends: openjdk-18-jre-headless
Restrictions: superficial

Test-Command: javac --version
Depends: openjdk-18-jdk-headless
Restrictions: superficial

#Tests: hotspot, jaxp, langtools
#Depends: @, default-jre-headless, jtreg:native (>= 6.1+1-0~), testng:native, build-essential
#Restrictions: allow-stderr, skippable, flaky

#Tests: jdk
#Depends: @, default-jre-headless, jtreg:native (>= 6.1+1-0~), testng:native, build-essential, xfwm4:native, xvfb, dbus-x11
#Restrictions: allow-stderr, skippable, flaky

=== debian/watch ===
version=4
opts="filenamemangle=s%(?:.*?)?jdk-(\d[\d.]*\+\d[\d]*)\.tar\.gz%<project>-$1.tar.gz%, dversionmangle=s/~/+/" \
   https://github.com/openjdk/jdk/tags \
   (?:.*?/)?jdk-(\d[\d.]*\+\d[\d]*)\.tar\.gz debian uupdate

## openjdk-18 18.0.2+9

=== debian/changelog ===
openjdk-18 (18.0.2+9-2~22.04) jammy-security; urgency=medium

  * OpenJDK 18.0.2 release, build 9.
  * Addresses security issues: CVE-2022-34169, CVE-2022-21541,
    CVE-2022-21540.

 -- Matthias Klose <doko@ubuntu.com>  Fri, 22 Jul 2022 10:44:23 +0200

openjdk-18 (18.0.2+9-2) unstable; urgency=medium

  * Don't hard-code the name of the jtreg package.

 -- Matthias Klose <doko@ubuntu.com>  Wed, 20 Jul 2022 18:25:51 +0200

openjdk-18 (18.0.2+9-1) unstable; urgency=high

  * OpenJDK 18.0.2 release, build 9.
  * Update maintainer address.
  * Update watch file.
  * Re-enable running the testsuite.
  * Only try to re-run failed tests once instead of three times.

 -- Matthias Klose <doko@ubuntu.com>  Wed, 20 Jul 2022 18:07:47 +0200

openjdk-18 (18.0.1+10-1) unstable; urgency=high

  * OpenJDK 18.0.1 release, build 10.
  * Security fixes
    - JDK-8269938: Enhance XML processing passes redux.
    - JDK-8270504, CVE-2022-21426: Better XPath expression handling.
    - JDK-8272255: Completely handle MIDI files.
    - JDK-8272261: Improve JFR recording file processing.
    - JDK-8272588: Enhanced recording parsing.
    - JDK-8272594: Better record of recordings.
    - JDK-8274221: More definite BER encodings.
    - JDK-8275082, JDK-8278008, CVE-2022-21476: Update XML Security for Java
      to 2.3.0.
    - JDK-8275151, CVE-2022-21443: Improved Object Identification.
    - JDK-8277227: Better identification of OIDs.
    - JDK-8277233, CVE-2022-21449: Improve ECDSA signature support.
    - JDK-8277672, CVE-2022-21434: Better invocation handler handling.
    - JDK-8278356: Improve file creation.
    - JDK-8278449: Improve keychain support.
    - JDK-8278798: Improve supported intrinsic.
    - JDK-8278805: Enhance BMP image loading.
    - JDK-8278972, CVE-2022-21496: Improve URL supports.
    - JDK-8281388: Change wrapping of EncryptedPrivateKeyInfo.
  * Update VCS attributes.

 -- Matthias Klose <doko@ubuntu.com>  Tue, 03 May 2022 00:06:23 +0200

=== debian/control ===
--- 
+++ 
@@ -1,13 +1,13 @@
 Source: openjdk-18
 Section: java
 Priority: optional
-Maintainer: OpenJDK Team <openjdk-17@packages.debian.org>
+Maintainer: OpenJDK Team <openjdk-18@packages.debian.org>
 Uploaders: Matthias Klose <doko@ubuntu.com>
 Build-Depends: debhelper (>= 11),
   m4, lsb-release, zip, unzip,
   sharutils, gawk, cpio, pkg-config, procps, wdiff, fastjar (>= 2:0.96-0ubuntu2),
   time, strip-nondeterminism, debugedit (>= 4.16),
-  file,
+  jtreg6 (>= 6.1+1-0~) <!nocheck>, testng <!nocheck>, xvfb <!nocheck>, xauth <!nocheck>, xfonts-base <!nocheck>, libgl1-mesa-dri [!x32] <!nocheck>, xfwm4 <!nocheck>, x11-xkb-utils <!nocheck>, dbus-x11 <!nocheck>,
   autoconf, automake, autotools-dev, ant, ant-optional,
   g++-11 <!cross>,
   openjdk-18-jdk-headless:native | openjdk-17-jdk-headless:native,
@@ -20,8 +20,8 @@
 Rules-Requires-Root: no
 Standards-Version: 4.6.0
 Homepage: https://openjdk.java.net/
-Vcs-Browser: https://salsa.debian.org/openjdk-team/openjdk
-Vcs-Git: https://salsa.debian.org/openjdk-team/openjdk.git
+Vcs-Browser: https://salsa.debian.org/openjdk-team/openjdk/tree/openjdk-18
+Vcs-Git: https://salsa.debian.org/openjdk-team/openjdk.git -b openjdk-18
 
 Package: openjdk-18-jdk-headless
 Architecture: alpha amd64 armel armhf arm64 i386 ia64 mips mipsel mips64 mips64el powerpc ppc64 ppc64el m68k riscv64 sh4 sparc sparc64 s390x x32

=== debian/rules ===
--- 
+++ 
@@ -105,20 +105,20 @@
 v_upstream	:= $(shell echo $(v_debian) | sed 's/-[^-][^-]*$$//')
 v_pkgrel	:= $(shell echo $(v_debian) | sed 's/^.*-//')
 # FIXME. currently v_upstream like 11~4
-#v_upbase	:= $(word 1, $(subst +, , $(v_upstream)))
-#v_upbuild	:= $(word 2, $(subst +, , $(v_upstream)))
-v_upbase	:= $(word 1, $(subst ~, , $(v_upstream)))
-v_upbuild	:= $(word 2, $(subst ~, , $(v_upstream)))
+v_upbase	:= $(word 1, $(subst +, , $(v_upstream)))
+v_upbuild	:= $(word 2, $(subst +, , $(v_upstream)))
+#v_upbase	:= $(word 1, $(subst ~, , $(v_upstream)))
+#v_upbuild	:= $(word 2, $(subst ~, , $(v_upstream)))
 # that should be the package version ...
 
 #$(warning XXXXX $(v_upstream) / $(v_pkgrel) / $(v_upbase) / $(v_upbuild))
 
-#ifneq ($(v_debian),$(v_upbase)+$(v_upbuild)-$(v_pkgrel))
-#  $(error wrong version: $(v_upbase)+$(v_upbuild)-$(v_pkgrel) should be: $(v_debian))
+ifneq ($(v_debian),$(v_upbase)+$(v_upbuild)-$(v_pkgrel))
+  $(error wrong version: $(v_upbase)+$(v_upbuild)-$(v_pkgrel) should be: $(v_debian))
+endif
+#ifneq ($(v_debian),$(v_upbase)~$(v_upbuild)-$(v_pkgrel))
+#  $(error wrong version: $(v_upbase)~$(v_upbuild)-$(v_pkgrel) should be: $(v_debian))
 #endif
-ifneq ($(v_debian),$(v_upbase)~$(v_upbuild)-$(v_pkgrel))
-  $(error wrong version: $(v_upbase)~$(v_upbuild)-$(v_pkgrel) should be: $(v_debian))
-endif
 
 ifneq (,$(DEB_HOST_MULTIARCH))
   jdirname	= java-$(shortver)-$(origin)-$(DEB_HOST_ARCH)
@@ -157,15 +157,16 @@
   NJOBS = $(subst parallel=,,$(filter parallel=%,$(subst $(COMMA), ,$(DEB_BUILD_OPTIONS))))
 endif
 
+jtreg_pkg = jtreg6
+
 with_check = $(if $(findstring nocheck, $(DEB_BUILD_OPTIONS)),,yes)
 ifneq (,$(filter $(DEB_HOST_ARCH), alpha armel mipsel mips64el riscv64))
   with_check = disabled running check on $(DEB_HOST_ARCH)
 endif
 # no jtreg backport yet
 ifneq (,$(filter $(distrel), precise trusty xenial bionic))
-  with_check = disabled for $(distrel)
-endif
-with_check = disabled, more recent jtreg needed
+  with_check = disabled for $(distrel), no $(jtreg_pkg)
+endif
 
 with_docs = $(if $(findstring nodoc, $(DEB_BUILD_OPTIONS)),,yes)
 ifneq (,$(filter $(distrel), precise trusty))

=== debian/watch ===
version=4
opts="filenamemangle=s%(?:.*?)?jdk-(\d[\d.]*\+\d[\d]*)\.tar\.gz%<project>-$1.tar.gz%, dversionmangle=s/~/+/" \
   https://github.com/openjdk/jdk18u/tags \
   (?:.*?/)?jdk-(\d[\d.]*\+\d[\d]*)\.tar\.gz debian uupdate
